Index: gcc/testsuite/gnat.dg/alignment13.adb
===================================================================
--- gcc/testsuite/gnat.dg/alignment13.adb	(.../tags/gcc_6_4_0_release)	(nonexistent)
+++ gcc/testsuite/gnat.dg/alignment13.adb	(.../branches/gcc-6-branch)
@@ -0,0 +1,21 @@
+-- { dg-do run }
+-- { dg-options "-gnatws" }
+
+procedure Alignment13 is
+
+  type Rec is record
+    I1 : aliased Short_Integer;
+    I2 : Integer;
+  end record;
+
+  for Rec use record
+    I1 at 0 range 0 .. 15;
+  end record;
+
+  R : Rec;
+
+begin
+  if R.I2'Bit_Position /= 32 then
+    raise Program_Error;
+  end if;
+end;
Index: gcc/testsuite/gnat.dg/disp1_pkg.ads
===================================================================
--- gcc/testsuite/gnat.dg/disp1_pkg.ads	(.../tags/gcc_6_4_0_release)	(nonexistent)
+++ gcc/testsuite/gnat.dg/disp1_pkg.ads	(.../branches/gcc-6-branch)
@@ -0,0 +1,6 @@
+package Disp1_Pkg is
+
+   type I1 is interface;
+   type DT_I1 is new I1 with null record;
+
+end Disp1_Pkg;
Index: gcc/testsuite/gnat.dg/disp2_pkg.adb
===================================================================
--- gcc/testsuite/gnat.dg/disp2_pkg.adb	(.../tags/gcc_6_4_0_release)	(nonexistent)
+++ gcc/testsuite/gnat.dg/disp2_pkg.adb	(.../branches/gcc-6-branch)
@@ -0,0 +1,8 @@
+package body Disp2_Pkg is
+
+  function Impl_Of (Self : access Object) return Object_Ptr is
+  begin
+    return Object_Ptr (Self);
+  end Impl_Of;
+
+end Disp2_Pkg;
Index: gcc/testsuite/gnat.dg/disp2_pkg.ads
===================================================================
--- gcc/testsuite/gnat.dg/disp2_pkg.ads	(.../tags/gcc_6_4_0_release)	(nonexistent)
+++ gcc/testsuite/gnat.dg/disp2_pkg.ads	(.../branches/gcc-6-branch)
@@ -0,0 +1,11 @@
+package Disp2_Pkg is
+
+  type Object     is tagged null record;
+  type Object_Ptr is access all Object'CLASS;
+
+  function Impl_Of (Self : access Object) return Object_Ptr;
+  function Get_Ptr (Self : access Object) return Object_Ptr
+    renames Impl_Of;
+
+end Disp2_Pkg;
+
Index: gcc/testsuite/gnat.dg/null_pointer_deref1.adb
===================================================================
--- gcc/testsuite/gnat.dg/null_pointer_deref1.adb	(.../tags/gcc_6_4_0_release)
+++ gcc/testsuite/gnat.dg/null_pointer_deref1.adb	(.../branches/gcc-6-branch)
@@ -17,5 +17,5 @@
 begin
    Data.all := 1;
 exception
-   when Constraint_Error | Storage_Error => null;
+   when others => null;
 end;
Index: gcc/testsuite/gnat.dg/specs/uc2.ads
===================================================================
--- gcc/testsuite/gnat.dg/specs/uc2.ads	(.../tags/gcc_6_4_0_release)	(nonexistent)
+++ gcc/testsuite/gnat.dg/specs/uc2.ads	(.../branches/gcc-6-branch)
@@ -0,0 +1,18 @@
+-- { dg-do compile }
+-- { dg-options "-O" }
+
+with Ada.Unchecked_Conversion;
+
+package UC2 is
+
+  subtype Word_Type is Integer range 0 .. 0;
+  type Arr is array (1 .. Word_Type'Size) of Boolean;
+  pragma Pack(Arr);
+
+  function Conv is
+     new Ada.Unchecked_Conversion (Source => Arr, Target => Word_Type);
+
+  A : Arr;
+  W : Word_Type := Conv(A);
+
+end UC2;
Index: gcc/testsuite/gnat.dg/null_pointer_deref2.adb
===================================================================
--- gcc/testsuite/gnat.dg/null_pointer_deref2.adb	(.../tags/gcc_6_4_0_release)
+++ gcc/testsuite/gnat.dg/null_pointer_deref2.adb	(.../branches/gcc-6-branch)
@@ -20,7 +20,7 @@
    begin
       Data.all := 1;
    exception
-      when Constraint_Error | Storage_Error => null;
+      when others => null;
    end T;
 
 begin
Index: gcc/testsuite/gcc.dg/pr82112.c
===================================================================
--- gcc/testsuite/gcc.dg/pr82112.c	(.../tags/gcc_6_4_0_release)	(nonexistent)
+++ gcc/testsuite/gcc.dg/pr82112.c	(.../branches/gcc-6-branch)
@@ -0,0 +1,21 @@
+/* PR target/82112 */
+/* { dg-do compile } */
+/* { dg-options "-std=gnu90" } */
+
+struct S { int a[10]; } bar (void);
+int b, c;
+
+void
+foo (void)
+{
+  __atomic_load (bar ().a, &b, __ATOMIC_ACQUIRE);	/* { dg-error "argument 1 of .__atomic_load. must be a non-void pointer type" } */
+  __atomic_load (&b, bar ().a, __ATOMIC_ACQUIRE);	/* { dg-error "argument 2 of .__atomic_load. must be a pointer type" } */
+  __atomic_store (bar ().a, &b, __ATOMIC_SEQ_CST);	/* { dg-error "argument 1 of .__atomic_store. must be a non-void pointer type" } */
+  __atomic_store (&b, bar ().a, __ATOMIC_SEQ_CST);	/* { dg-error "argument 2 of .__atomic_store. must be a pointer type" } */
+  __atomic_exchange (bar ().a, &b, &c, __ATOMIC_RELAXED);	/* { dg-error "argument 1 of .__atomic_exchange. must be a non-void pointer type" } */
+  __atomic_exchange (&b, bar ().a, &c, __ATOMIC_RELAXED);	/* { dg-error "argument 2 of .__atomic_exchange. must be a pointer type" } */
+  __atomic_exchange (&b, &c, bar ().a, __ATOMIC_RELAXED);	/* { dg-error "argument 3 of .__atomic_exchange. must be a pointer type" } */
+  __atomic_compare_exchange (bar ().a, &b, &c, 1, __ATOMIC_RELAXED, __ATOMIC_RELAXED);	/* { dg-error "argument 1 of .__atomic_compare_exchange. must be a non-void pointer type" } */
+  __atomic_compare_exchange (&b, bar ().a, &c, 1, __ATOMIC_RELAXED, __ATOMIC_RELAXED);	/* { dg-error "argument 2 of .__atomic_compare_exchange. must be a pointer type" } */
+  __atomic_compare_exchange (&b, &c, bar ().a, 1, __ATOMIC_RELAXED, __ATOMIC_RELAXED);	/* { dg-error "argument 3 of .__atomic_compare_exchange. must be a pointer type" } */
+}
Index: gcc/testsuite/gcc.dg/gomp/pr81768-2.c
===================================================================
--- gcc/testsuite/gcc.dg/gomp/pr81768-2.c	(.../tags/gcc_6_4_0_release)	(nonexistent)
+++ gcc/testsuite/gcc.dg/gomp/pr81768-2.c	(.../branches/gcc-6-branch)
@@ -0,0 +1,15 @@
+/* PR middle-end/81768 */
+/* { dg-do compile } */
+
+float b[10][15][10];
+
+void
+foo (void)
+{
+  float *i;
+#pragma omp target parallel for schedule(static, 32) collapse(3)
+  for (i = &b[0][0][0]; i < &b[0][0][10]; i++)
+    for (float *j = &b[0][15][0]; j > &b[0][0][0]; j -= 10)
+      for (float *k = &b[0][0][10]; k > &b[0][0][0]; --k)
+        b[i - &b[0][0][0]][(j - &b[0][0][0]) / 10 - 1][(k - &b[0][0][0]) - 1] -= 3.5;
+}
Index: gcc/testsuite/gcc.dg/gomp/pr81768-1.c
===================================================================
--- gcc/testsuite/gcc.dg/gomp/pr81768-1.c	(.../tags/gcc_6_4_0_release)	(nonexistent)
+++ gcc/testsuite/gcc.dg/gomp/pr81768-1.c	(.../branches/gcc-6-branch)
@@ -0,0 +1,15 @@
+/* PR middle-end/81768 */
+/* { dg-do compile } */
+
+float b[10][15][10];
+
+void
+foo (void)
+{
+  float *i;
+#pragma omp target parallel for simd schedule(static, 32) collapse(3)
+  for (i = &b[0][0][0]; i < &b[0][0][10]; i++)
+    for (float *j = &b[0][15][0]; j > &b[0][0][0]; j -= 10)
+      for (float *k = &b[0][0][10]; k > &b[0][0][0]; --k)
+	b[i - &b[0][0][0]][(j - &b[0][0][0]) / 10 - 1][(k - &b[0][0][0]) - 1] -= 3.5;
+}
Index: gcc/testsuite/gcc.dg/pr82274-2.c
===================================================================
--- gcc/testsuite/gcc.dg/pr82274-2.c	(.../tags/gcc_6_4_0_release)	(nonexistent)
+++ gcc/testsuite/gcc.dg/pr82274-2.c	(.../branches/gcc-6-branch)
@@ -0,0 +1,22 @@
+/* PR target/82274 */
+/* { dg-do run } */
+/* { dg-options "-O2" } */
+
+int
+main ()
+{
+#ifdef __SIZEOF_INT128__
+  __int128 m = -(((__int128) 1) << (__CHAR_BIT__ * __SIZEOF_INT128__ / 2));
+  volatile __int128 mv = m;
+  __int128 r;
+#else
+  long long m = -(1LL << (__CHAR_BIT__ * __SIZEOF_LONG_LONG__ / 2));
+  volatile long long mv = m;
+  long long r;
+#endif
+  if (!__builtin_mul_overflow (mv, mv, &r))
+    __builtin_abort ();
+  if (!__builtin_mul_overflow (m, m, &r))
+    __builtin_abort ();
+  return 0;
+}
Index: gcc/testsuite/gcc.dg/debug/dwarf2/prod-options.c
===================================================================
--- gcc/testsuite/gcc.dg/debug/dwarf2/prod-options.c	(.../tags/gcc_6_4_0_release)
+++ gcc/testsuite/gcc.dg/debug/dwarf2/prod-options.c	(.../branches/gcc-6-branch)
@@ -3,9 +3,8 @@
    the build not reproducible.  Other skipped options could be tested here
    as well.  */
 /* { dg-do compile } */
-/* { dg-options "-O2 -gdwarf -dA -fdebug-prefix-map=a=b" } */
-/* { dg-final { scan-assembler "DW_AT_producer: \"GNU C" { target { { { ! *-*-solaris2* } || gas } && { ! hppa*64*-*-* } } } } } */
-/* { dg-final { scan-assembler "\"GNU C\[^\\n\\r\]+ DW_AT_producer" { target { { *-*-solaris2* && { ! gas } } || { hppa*64*-*-* } } } } } */
+/* { dg-options "-O2 -gdwarf -dA -fno-merge-debug-strings -fdebug-prefix-map=a=b" } */
+/* { dg-final { scan-assembler "\"GNU C\[^\\n\\r\]+ DW_AT_producer" } } */
 /* { dg-final { scan-assembler-not "debug-prefix-map" } } */
 
 void func (void)
Index: gcc/testsuite/gcc.dg/ubsan/pr81162.c
===================================================================
--- gcc/testsuite/gcc.dg/ubsan/pr81162.c	(.../tags/gcc_6_4_0_release)	(nonexistent)
+++ gcc/testsuite/gcc.dg/ubsan/pr81162.c	(.../branches/gcc-6-branch)
@@ -0,0 +1,17 @@
+/* PR tree-optimization/81162 */
+/* { dg-do run } */
+/* { dg-options "-fsanitize=undefined -O2" } */
+
+short s;
+int i1 = 1;
+int i2 = 1;
+unsigned char uc = 147;
+
+int main() {
+  s = (-uc + 2147483647) << 0;
+  if (9031239389974324562ULL >= (-((i1 && i2) + uc) ^ -21096) ) {
+    return 0;
+  } else {
+    return -1;
+  }
+}
Index: gcc/testsuite/gcc.dg/ubsan/pr81505.c
===================================================================
--- gcc/testsuite/gcc.dg/ubsan/pr81505.c	(.../tags/gcc_6_4_0_release)	(nonexistent)
+++ gcc/testsuite/gcc.dg/ubsan/pr81505.c	(.../branches/gcc-6-branch)
@@ -0,0 +1,17 @@
+/* { dg-do compile } */
+/* { dg-options "-O3 -fsanitize=signed-integer-overflow" } */
+
+int a, b, c, h;
+
+int i[5][5];
+
+void
+fn1 ()
+{
+  int l = 0;
+
+  for (a = 0; a <= 3; a++)
+    for (b = 1; b >= 0; b -= 1)
+      l |= i[0][b];
+  c = l;
+}
Index: gcc/testsuite/gcc.dg/pr83424.c
===================================================================
--- gcc/testsuite/gcc.dg/pr83424.c	(.../tags/gcc_6_4_0_release)	(nonexistent)
+++ gcc/testsuite/gcc.dg/pr83424.c	(.../branches/gcc-6-branch)
@@ -0,0 +1,30 @@
+/* PR rtl-optimization/83424 */
+/* { dg-do run { target int128 } } */
+/* { dg-options "-O -fno-tree-ccp -fno-tree-coalesce-vars" } */
+
+typedef unsigned char u8;
+typedef unsigned int u32;
+typedef unsigned __int128 u128;
+
+u32 a, c;
+u8 b;
+
+static u128 __attribute__ ((noinline, noclone))
+foo (u128 p)
+{
+  u8 x = ~b;
+  p &= c;
+  x *= -p;
+  x &= a == 0;
+  x >>= 1;
+  return p + x;
+}
+
+int
+main (void)
+{
+  u128 x = foo (0);
+  if (x != 0)
+    __builtin_abort ();
+  return 0;
+}
Index: gcc/testsuite/gcc.dg/pr84956.c
===================================================================
--- gcc/testsuite/gcc.dg/pr84956.c	(.../tags/gcc_6_4_0_release)	(nonexistent)
+++ gcc/testsuite/gcc.dg/pr84956.c	(.../branches/gcc-6-branch)
@@ -0,0 +1,27 @@
+/* { dg-options "-O2 -ftree-tail-merge" } */
+
+char a;
+int c;
+unsigned b ();
+
+unsigned
+setjmp ()
+{
+}
+
+static void
+d ()
+{
+  if (b ())
+    c = 3;
+}
+
+void
+e ()
+{
+  d ();
+  a && ({ setjmp (); });
+  a && ({ setjmp (); });
+  a && ({ setjmp (); });
+}
+
Index: gcc/testsuite/gcc.dg/pr79499.c
===================================================================
--- gcc/testsuite/gcc.dg/pr79499.c	(.../tags/gcc_6_4_0_release)	(nonexistent)
+++ gcc/testsuite/gcc.dg/pr79499.c	(.../branches/gcc-6-branch)
@@ -0,0 +1,13 @@
+/* PR middle-end/79499 */
+/* { dg-do compile { target split_stack } } */
+/* { dg-options "-O2 -fsplit-stack -fno-omit-frame-pointer" } */
+
+struct S { struct S *a, *b; };
+
+void
+foo (struct S *x)
+{
+  do
+    x->b = x->a;
+  while (x = x->a);
+}
Index: gcc/testsuite/gcc.dg/pr81621.c
===================================================================
--- gcc/testsuite/gcc.dg/pr81621.c	(.../tags/gcc_6_4_0_release)	(nonexistent)
+++ gcc/testsuite/gcc.dg/pr81621.c	(.../branches/gcc-6-branch)
@@ -0,0 +1,5 @@
+/* PR target/81621 */
+/* { dg-do compile { target freorder } } */
+/* { dg-options "-Og -fno-split-wide-types -freorder-blocks-and-partition" } */
+
+#include "graphite/scop-10.c"
Index: gcc/testsuite/gcc.dg/lto/pr81440.h
===================================================================
--- gcc/testsuite/gcc.dg/lto/pr81440.h	(.../tags/gcc_6_4_0_release)	(nonexistent)
+++ gcc/testsuite/gcc.dg/lto/pr81440.h	(.../branches/gcc-6-branch)
@@ -0,0 +1,4 @@
+typedef struct {
+  int i;
+  int ints[];
+} struct_t;
Index: gcc/testsuite/gcc.dg/lto/pr81440_0.c
===================================================================
--- gcc/testsuite/gcc.dg/lto/pr81440_0.c	(.../tags/gcc_6_4_0_release)	(nonexistent)
+++ gcc/testsuite/gcc.dg/lto/pr81440_0.c	(.../branches/gcc-6-branch)
@@ -0,0 +1,9 @@
+/* { dg-lto-do link } */
+
+#include "pr81440.h"
+
+extern struct_t my_struct;
+
+int main() {
+ return my_struct.ints[0];
+}
Index: gcc/testsuite/gcc.dg/lto/pr83954_0.c
===================================================================
--- gcc/testsuite/gcc.dg/lto/pr83954_0.c	(.../tags/gcc_6_4_0_release)	(nonexistent)
+++ gcc/testsuite/gcc.dg/lto/pr83954_0.c	(.../branches/gcc-6-branch)
@@ -0,0 +1,8 @@
+/* { dg-lto-do link } */
+#include "pr83954.h"
+
+int main() {
+  // just to prevent symbol removal
+  FOO_PTR_ARR[1] = 0;
+  return 0;
+}
Index: gcc/testsuite/gcc.dg/lto/pr81440_1.c
===================================================================
--- gcc/testsuite/gcc.dg/lto/pr81440_1.c	(.../tags/gcc_6_4_0_release)	(nonexistent)
+++ gcc/testsuite/gcc.dg/lto/pr81440_1.c	(.../branches/gcc-6-branch)
@@ -0,0 +1,6 @@
+#include "pr81440.h"
+
+struct_t my_struct = {
+ 20,
+ { 1, 2 }
+};
Index: gcc/testsuite/gcc.dg/lto/pr83954.h
===================================================================
--- gcc/testsuite/gcc.dg/lto/pr83954.h	(.../tags/gcc_6_4_0_release)	(nonexistent)
+++ gcc/testsuite/gcc.dg/lto/pr83954.h	(.../branches/gcc-6-branch)
@@ -0,0 +1,3 @@
+struct foo;
+extern struct foo *FOO_PTR_ARR[1];
+
Index: gcc/testsuite/gcc.dg/lto/pr83954_1.c
===================================================================
--- gcc/testsuite/gcc.dg/lto/pr83954_1.c	(.../tags/gcc_6_4_0_release)	(nonexistent)
+++ gcc/testsuite/gcc.dg/lto/pr83954_1.c	(.../branches/gcc-6-branch)
@@ -0,0 +1,7 @@
+#include "pr83954.h"
+
+struct foo {
+ int x;
+};
+struct foo *FOO_PTR_ARR[1] = { 0 };
+
Index: gcc/testsuite/gcc.dg/pr81192.c
===================================================================
--- gcc/testsuite/gcc.dg/pr81192.c	(.../tags/gcc_6_4_0_release)	(nonexistent)
+++ gcc/testsuite/gcc.dg/pr81192.c	(.../branches/gcc-6-branch)
@@ -0,0 +1,22 @@
+/* { dg-options "-Os -fdump-tree-pre-details" } */
+
+unsigned a;
+int b, c;
+
+static int
+fn1 (int p1, int p2)
+{
+  return p1 > 2147483647 - p2 ? p1 : p1 + p2;
+}
+
+void
+fn2 (void)
+{
+  int j;
+  a = 30;
+  for (; a;)
+    for (; c; b = fn1 (j, 1))
+      ;
+}
+
+/* { dg-final { scan-tree-dump-times "(?n)find_duplicates: <bb .*> duplicate of <bb .*>" 1 "pre" } } */
Index: gcc/testsuite/gcc.dg/torture/pr75964.c
===================================================================
--- gcc/testsuite/gcc.dg/torture/pr75964.c	(.../tags/gcc_6_4_0_release)	(nonexistent)
+++ gcc/testsuite/gcc.dg/torture/pr75964.c	(.../branches/gcc-6-branch)
@@ -0,0 +1,28 @@
+/* { dg-do run } */
+
+typedef __UINT8_TYPE__ uint8_t;
+
+uint8_t __attribute__ ((noinline, noclone))
+abs8 (uint8_t x)
+{
+  if (x & 0x80)
+    x = -x;
+
+  if (x & 0x80)
+    x = 0x7f;
+
+  return x;
+}
+
+int
+main (void)
+{
+  if (abs8 (0) != 0
+      || abs8 (1) != 1
+      || abs8 (127) != 127
+      || abs8 (128) != 127
+      || abs8 (129) != 127
+      || abs8 (255) != 1)
+    __builtin_abort ();
+  return 0;
+}
Index: gcc/testsuite/gcc.dg/torture/pr60092.c
===================================================================
--- gcc/testsuite/gcc.dg/torture/pr60092.c	(.../tags/gcc_6_4_0_release)
+++ gcc/testsuite/gcc.dg/torture/pr60092.c	(.../branches/gcc-6-branch)
@@ -4,7 +4,6 @@
 /* { dg-skip-if "No undefined weak" { nvptx-*-* } { "*" } { "" } } */
 /* { dg-additional-options "-Wl,-undefined,dynamic_lookup" { target *-*-darwin* } } */
 /* { dg-additional-options "-Wl,-flat_namespace" { target *-*-darwin[89]* } } */
-/* { dg-xfail-run-if "posix_memalign modifies first arg on error" { *-*-solaris2.11* } { "-O0" } } */
 
 typedef __SIZE_TYPE__ size_t;
 extern int posix_memalign(void **memptr, size_t alignment, size_t size) __attribute__((weak));
Index: gcc/testsuite/gcc.dg/torture/pr80341.c
===================================================================
--- gcc/testsuite/gcc.dg/torture/pr80341.c	(.../tags/gcc_6_4_0_release)	(nonexistent)
+++ gcc/testsuite/gcc.dg/torture/pr80341.c	(.../branches/gcc-6-branch)
@@ -0,0 +1,20 @@
+/* { dg-do run } */
+/* { dg-additional-options "-Wno-overflow" } */
+/* { dg-require-effective-target int32plus } */
+
+const signed char c = -84;
+signed char s;
+
+void
+foo ()
+{
+  s = (unsigned short) c / -55;
+}
+
+int
+main ()
+{
+  foo ();
+  if (s != 90)
+    __builtin_abort ();
+}
Index: gcc/testsuite/gcc.dg/torture/pr80281.c
===================================================================
--- gcc/testsuite/gcc.dg/torture/pr80281.c	(.../tags/gcc_6_4_0_release)	(nonexistent)
+++ gcc/testsuite/gcc.dg/torture/pr80281.c	(.../branches/gcc-6-branch)
@@ -0,0 +1,14 @@
+/* { dg-run } */
+/* { dg-require-effective-target int32plus } */
+
+int
+main ()
+{
+  volatile int a = 0;
+  long long b = 2147483648LL;
+  int c = a % 2;
+  int x = ((int) -b + c) % -2147483647;
+  if (x != -1)
+    __builtin_abort ();
+  return 0;
+}
Index: gcc/testsuite/gcc.dg/torture/pr79732.c
===================================================================
--- gcc/testsuite/gcc.dg/torture/pr79732.c	(.../tags/gcc_6_4_0_release)
+++ gcc/testsuite/gcc.dg/torture/pr79732.c	(.../branches/gcc-6-branch)
@@ -1,4 +1,5 @@
 /* { dg-do link } */
+/* { dg-require-alias "" } */
 
 int bar () __attribute__ ((alias ("foo")));
 void foo () { }
Index: gcc/testsuite/gcc.dg/pr82975.c
===================================================================
--- gcc/testsuite/gcc.dg/pr82975.c	(.../tags/gcc_6_4_0_release)	(nonexistent)
+++ gcc/testsuite/gcc.dg/pr82975.c	(.../branches/gcc-6-branch)
@@ -0,0 +1,20 @@
+/* PR target/82975.  */
+/* { dg-do compile } */
+/* { dg-options "-fno-sched-pressure -O2" } */
+/* { dg-additional-options "-mtune=cortex-a57" { target arm*-*-* aarch64*-*-* } } */
+
+typedef __SIZE_TYPE__ size_t;
+
+struct S1
+{
+  char pad1;
+  char val;
+  short pad2;
+};
+
+extern char t[256];
+
+void foo (struct S1 a, size_t i)
+{
+  t[i] = a.val;
+}
Index: gcc/testsuite/gcc.dg/tree-ssa/pr82726.c
===================================================================
--- gcc/testsuite/gcc.dg/tree-ssa/pr82726.c	(.../tags/gcc_6_4_0_release)	(nonexistent)
+++ gcc/testsuite/gcc.dg/tree-ssa/pr82726.c	(.../branches/gcc-6-branch)
@@ -0,0 +1,26 @@
+/* { dg-do compile } */
+/* { dg-options "-O3 --param tree-reassoc-width=4" } */
+/* { dg-additional-options "-mavx2" { target { x86_64-*-* i?86-*-* } } } */
+
+#define N 40
+#define M 128
+unsigned int in[N+M];
+unsigned short out[N];
+
+/* Outer-loop vectorization. */
+
+void
+foo (){
+  int i,j;
+  unsigned int diff;
+
+  for (i = 0; i < N; i++) {
+    diff = 0;
+    for (j = 0; j < M; j+=8) {
+      diff += in[j+i];
+    }
+    out[i]=(unsigned short)diff;
+  }
+
+  return;
+}
Index: gcc/testsuite/gcc.dg/ipa/pr82001.c
===================================================================
--- gcc/testsuite/gcc.dg/ipa/pr82001.c	(.../tags/gcc_6_4_0_release)	(nonexistent)
+++ gcc/testsuite/gcc.dg/ipa/pr82001.c	(.../branches/gcc-6-branch)
@@ -0,0 +1,21 @@
+/* { dg-do compile { target i?86-*-* x86_64-*-* } } */
+/* { dg-options "-O2 -fdump-ipa-icf-details"  } */
+
+int
+mullo (int a, int b)
+{
+  asm("mul %%edx   # %%1 was %1"
+      : "+"
+	"a"(a),
+	"+d"(b));
+  return a;
+}
+
+int
+mulhi (int a, int b)
+{
+  asm("mul %%edx   # %%1 was %1" : "+d"(a), "+a"(b));
+  return a;
+}
+
+/* { dg-final { scan-ipa-dump "Equal symbols: 0" "icf"  } } */
Index: gcc/testsuite/gcc.dg/ipa/pr81696.c
===================================================================
--- gcc/testsuite/gcc.dg/ipa/pr81696.c	(.../tags/gcc_6_4_0_release)	(nonexistent)
+++ gcc/testsuite/gcc.dg/ipa/pr81696.c	(.../branches/gcc-6-branch)
@@ -0,0 +1,26 @@
+/* { dg-options "-O2 -fdump-ipa-icf-details"  } */
+
+int
+main (int argc, char **argv)
+{
+  __label__ lab4, lab5, lab6;
+
+  void foo (void) { goto lab4; }
+  void foo2 (void) { goto lab4; }
+  void bar (void) { goto lab5; }
+  void baz (void) { goto lab6; }
+
+  if (argc)
+    foo ();
+  else
+    foo2 ();
+
+ lab4:;
+  bar ();
+ lab5:;
+  baz ();
+ lab6:;
+  return 0;
+}
+
+/* { dg-final { scan-ipa-dump "Equal symbols: 1" "icf"  } } */
Index: gcc/testsuite/gcc.dg/loop-8.c
===================================================================
--- gcc/testsuite/gcc.dg/loop-8.c	(.../tags/gcc_6_4_0_release)
+++ gcc/testsuite/gcc.dg/loop-8.c	(.../branches/gcc-6-branch)
@@ -1,6 +1,6 @@
 /* { dg-do compile } */
 /* { dg-options "-O1 -fdump-rtl-loop2_invariant" } */
-/* { dg-skip-if "unexpected IV" { "hppa*-*-* visium-*-*" } { "*" } { "" } } */
+/* { dg-skip-if "unexpected IV" { "hppa*-*-* visium-*-* powerpc*-*-*" } { "*" } { "" } } */
 
 void
 f (int *a, int *b)
Index: gcc/testsuite/gcc.dg/pr82274-1.c
===================================================================
--- gcc/testsuite/gcc.dg/pr82274-1.c	(.../tags/gcc_6_4_0_release)	(nonexistent)
+++ gcc/testsuite/gcc.dg/pr82274-1.c	(.../branches/gcc-6-branch)
@@ -0,0 +1,16 @@
+/* PR target/82274 */
+/* { dg-do run } */
+/* { dg-shouldfail "trapv" } */
+/* { dg-options "-ftrapv" } */
+
+int
+main ()
+{
+#ifdef __SIZEOF_INT128__
+  volatile __int128 m = -(((__int128) 1) << (__CHAR_BIT__ * __SIZEOF_INT128__ / 2));
+#else
+  volatile long long m = -(1LL << (__CHAR_BIT__ * __SIZEOF_LONG_LONG__ / 2));
+#endif
+  m = m * m;
+  return 0;
+}
